
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;


library work;
--use work.bramAsLutPack_64x4.ALL;	--Add the correct Package to configure the actual size of the Bram-LUT
--use work.bramAsLutPack_16x3.ALL;
use work.bramAsLutPack_16x2.ALL;

--Infers a BRAM. With init, it is used as a LUT with 4 Bit Address and 2 Bit Data
--Caution: For small sizes, XST infers LUTs. Set HDL Option ram_style to block to force. 
ENTITY bramaslut is
	
	PORT (
		clk : in std_logic;
		we : in std_logic;		--write enable								--is constantly 0
		waddr : in std_logic_vector(BramLenInBits - 1 downto 0);		--is constantly 0
		wdata : in std_logic_vector(DataBitSize - 1 downto 0);		--is constantly 0
		raddr : in std_logic_vector(BramLeninBits - 1 downto 0);
		rdata : out unsigned(DataBitSize - 1 downto 0)
	);
END bramaslut;

ARCHITECTURE Behavioral of bramaslut is

--Declaration of type and signal for a RAM
signal ram : ram_t := initConst;	--Type is in bramAsLutPack_MxN

BEGIN

	--process for read operation.
	PROCESS(clk)
	BEGIN
	   IF clk'event AND clk = '1' then
			IF (we = '1') THEN
				ram(to_integer(unsigned(waddr))) <= wdata;
			END IF;
			rdata <= unsigned(ram(to_integer(unsigned(raddr))));
	   END IF;
	END PROCESS;

END Behavioral;













