
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.numeric_std.ALL;

library work;
use work.allconstantsPack.ALL;
 
ENTITY tb_expanddisp IS
END tb_expanddisp;
 
ARCHITECTURE behavior OF tb_expanddisp IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT expandisparity
    PORT(
        clk : IN std_logic;
        reset : IN std_logic;
        colc : IN unsigned(ImageWidthInBits - 1 to 0);
        indexin : IN unsigned(7 downto 0);
		prevdispin : in unsigned(7 downto 0);
		expandout : out expanddispType
	);
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '0';
   signal colc : unsigned(ImageWidthInBits - 1 downto 0) := (others => '0');
   signal indexin : unsigned(7 downto 0) := (others => '0');
   signal prevdispin : unsigned(7 downto 0) := (others => '0');
   
   signal expandout : expanddispType;

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: expandisparity PORT MAP (
          clk => clk,
          reset => reset,
          colc => colc,
          indexin => indexin,
		  prevdispin => prevdispin,
		  expandout => expandout
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

   -- Stimulus process
	stim_proc1 : process
	BEGIN
		wait for clk_period * 2;
		FOR i In 1 TO IMAGEWIDTH LOOP
			colc <= to_unsigned(i,ImageWidthinBits);
			wait for clk_period;
		END LOOP;
		
		report "Alles gut" severity failure;
		
	END PROCESS;
   
	stimproc3 : process
	BEGIN
		wait for clk_period * 2;
		wait for clk_period * D;
		
		FOR i IN 1 TO D LOOP
			prevdispin <= to_unsigned(i,8);
			wait for clk_period;
		END LOOP;
	END PROCESS;
  
   
   stim_proc2: process
   begin		
		reset <= '1';
		wait for clk_period * 2;
		reset <= '0';
		
		wait for clk_period * D;
		
		indexin <= to_unsigned(1,8);
		wait for clk_period * D;
		
		indexin <= to_unsigned(2,8);
		wait for clk_period * D;
		
		indexin <= to_unsigned(3,8);
		wait for clk_period * D;
		
		indexin <= to_unsigned(4,8);
		wait for clk_period * D;
		
		indexin <= to_unsigned(D-1,8);
		wait for clk_period;
		
		indexin <= to_unsigned(D-2,8);
		wait for clk_period;
		
		indexin <= to_unsigned(0,8);
		wait for clk_period;
		
		indexin <= to_unsigned(200,8);
		wait for clk_period;
		
		indexin <= to_unsigned(100,8);
		wait for clk_period;
		
		wait;
      
   end process;

END;
