
--file automatically generated on 07-Apr-2014 17:43:35

library IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.NUMERIC_STD.ALL;

library work;
use work.allconstantsPack.ALL;

ENTITY findmaxreg16 IS
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		enable : IN std_logic;
		ready : OUT std_logic;
		medvector0 : IN pixelBitWidthpipeLenDType;
		outind : OUT unsigned(7 DOWNTO 0);
		outindvec : indvecType;
		outval : OUT unsigned(7 DOWNTO 0)
	);
END ENTITY findmaxreg16;

ARCHITECTURE Behavioral OF findmaxreg16 IS

CONSTANT medindex0INIT : pixelBitWidthpipeLenDType := indices(D);

signal indsig, indsig_next : unsigned(7 DOWNTO 0);
signal valsig, valsig_next : unsigned(7 DOWNTO 0);

signal indvecsig, indvecsig_next : indvecType;

signal medindex0 : pixelBitWidthpipeLenDType := medindex0INIT;

type medvectorType1 IS ARRAY(NATURAL RANGE 1 TO 8) OF unsigned(7 DOWNTO 0);
signal medvector1, medvector_next1 : medvectorType1;
signal medindex1, medindex_next1 : medvectorType1;

type medvectorType2 IS ARRAY(NATURAL RANGE 1 TO 4) OF unsigned(7 DOWNTO 0);
signal medvector2, medvector_next2 : medvectorType2;
signal medindex2, medindex_next2 : medvectorType2;

type medvectorType3 IS ARRAY(NATURAL RANGE 1 TO 2) OF unsigned(7 DOWNTO 0);
signal medvector3, medvector_next3 : medvectorType3;
signal medindex3, medindex_next3 : medvectorType3;

type medvectorType4 IS ARRAY(NATURAL RANGE 1 TO 1) OF unsigned(7 DOWNTO 0);
signal medvector4, medvector_next4 : medvectorType4;
signal medindex4, medindex_next4 : medvectorType4;


BEGIN
	clkProc : PROCESS(clk, reset)
	BEGIN
		IF reset = '1' THEN
			indsig <= (OTHERS => '0');
			valsig <= (OTHERS => '0');
			indvecsig <= (OTHERS => (OTHERS => '0'));
			medvector1 <= (OTHERS => (OTHERS => '0'));
			medindex1 <= (OTHERS => (OTHERS => '0'));
			medvector2 <= (OTHERS => (OTHERS => '0'));
			medindex2 <= (OTHERS => (OTHERS => '0'));
			medvector3 <= (OTHERS => (OTHERS => '0'));
			medindex3 <= (OTHERS => (OTHERS => '0'));
			medvector4 <= (OTHERS => (OTHERS => '0'));
			medindex4 <= (OTHERS => (OTHERS => '0'));
		ELSIF (clk'event AND clk = '1') THEN
			indsig <= indsig_next;
			valsig <= valsig_next;
			indvecsig <= indvecsig_next;
			medvector1 <= medvector_next1;
			medindex1 <= medindex_next1;
			medvector2 <= medvector_next2;
			medindex2 <= medindex_next2;
			medvector3 <= medvector_next3;
			medindex3 <= medindex_next3;
			medvector4 <= medvector_next4;
			medindex4 <= medindex_next4;
		END IF;
	END PROCESS;


	medvector0Proc : PROCESS(medvector0, medindex0)
	BEGIN
		IF medvector0(1) >= medvector0(2) THEN
			medvector_next1(1) <= medvector0(1);
			medindex_next1(1) <= medindex0(1);
		ELSE
			medvector_next1(1) <= medvector0(2);
			medindex_next1(1) <= medindex0(2);
		END IF;

		IF medvector0(3) >= medvector0(4) THEN
			medvector_next1(2) <= medvector0(3);
			medindex_next1(2) <= medindex0(3);
		ELSE
			medvector_next1(2) <= medvector0(4);
			medindex_next1(2) <= medindex0(4);
		END IF;

		IF medvector0(5) >= medvector0(6) THEN
			medvector_next1(3) <= medvector0(5);
			medindex_next1(3) <= medindex0(5);
		ELSE
			medvector_next1(3) <= medvector0(6);
			medindex_next1(3) <= medindex0(6);
		END IF;

		IF medvector0(7) >= medvector0(8) THEN
			medvector_next1(4) <= medvector0(7);
			medindex_next1(4) <= medindex0(7);
		ELSE
			medvector_next1(4) <= medvector0(8);
			medindex_next1(4) <= medindex0(8);
		END IF;

		IF medvector0(9) >= medvector0(10) THEN
			medvector_next1(5) <= medvector0(9);
			medindex_next1(5) <= medindex0(9);
		ELSE
			medvector_next1(5) <= medvector0(10);
			medindex_next1(5) <= medindex0(10);
		END IF;

		IF medvector0(11) >= medvector0(12) THEN
			medvector_next1(6) <= medvector0(11);
			medindex_next1(6) <= medindex0(11);
		ELSE
			medvector_next1(6) <= medvector0(12);
			medindex_next1(6) <= medindex0(12);
		END IF;

		IF medvector0(13) >= medvector0(14) THEN
			medvector_next1(7) <= medvector0(13);
			medindex_next1(7) <= medindex0(13);
		ELSE
			medvector_next1(7) <= medvector0(14);
			medindex_next1(7) <= medindex0(14);
		END IF;

		IF medvector0(15) >= medvector0(16) THEN
			medvector_next1(8) <= medvector0(15);
			medindex_next1(8) <= medindex0(15);
		ELSE
			medvector_next1(8) <= medvector0(16);
			medindex_next1(8) <= medindex0(16);
		END IF;

	END PROCESS;

	--next stage:
	medvector1Proc : PROCESS(medvector1, medindex1)
	BEGIN
		IF medvector1(1) >= medvector1(2) THEN
			medvector_next2(1) <= medvector1(1);
			medindex_next2(1) <= medindex1(1);
		ELSE
			medvector_next2(1) <= medvector1(2);
			medindex_next2(1) <= medindex1(2);
		END IF;

		IF medvector1(3) >= medvector1(4) THEN
			medvector_next2(2) <= medvector1(3);
			medindex_next2(2) <= medindex1(3);
		ELSE
			medvector_next2(2) <= medvector1(4);
			medindex_next2(2) <= medindex1(4);
		END IF;

		IF medvector1(5) >= medvector1(6) THEN
			medvector_next2(3) <= medvector1(5);
			medindex_next2(3) <= medindex1(5);
		ELSE
			medvector_next2(3) <= medvector1(6);
			medindex_next2(3) <= medindex1(6);
		END IF;

		IF medvector1(7) >= medvector1(8) THEN
			medvector_next2(4) <= medvector1(7);
			medindex_next2(4) <= medindex1(7);
		ELSE
			medvector_next2(4) <= medvector1(8);
			medindex_next2(4) <= medindex1(8);
		END IF;

	END PROCESS;

	--next stage:
	medvector2Proc : PROCESS(medvector2, medindex2)
	BEGIN
		IF medvector2(1) >= medvector2(2) THEN
			medvector_next3(1) <= medvector2(1);
			medindex_next3(1) <= medindex2(1);
		ELSE
			medvector_next3(1) <= medvector2(2);
			medindex_next3(1) <= medindex2(2);
		END IF;

		IF medvector2(3) >= medvector2(4) THEN
			medvector_next3(2) <= medvector2(3);
			medindex_next3(2) <= medindex2(3);
		ELSE
			medvector_next3(2) <= medvector2(4);
			medindex_next3(2) <= medindex2(4);
		END IF;

	END PROCESS;

	--next stage:
	medvector3Proc : PROCESS(medvector3, medindex3)
	BEGIN
		IF medvector3(1) >= medvector3(2) THEN
			medvector_next4(1) <= medvector3(1);
			medindex_next4(1) <= medindex3(1);
		ELSE
			medvector_next4(1) <= medvector3(2);
			medindex_next4(1) <= medindex3(2);
		END IF;

	END PROCESS;

	--next stage:
	--sorry, final stage:
	medvector4Proc : PROCESS(medvector4, medindex4)
	BEGIN
		IF medvector4(1) >= medvector4(2) THEN
			valsig_next <= medvector4(1);
			indsig_next <= medindex4(1);
		ELSE
			valsig_next <= medvector4(2);
			indsig_next <= medindex4(2);
		END IF;
	END PROCESS;
	
	indsigvectorProc : PROCESS(indsig)
	BEGIN
		indvecsig_next <= (OTHERS => (OTHERS => '0'));
		indvecsig_next(3) <= indsig;
		IF indsig >= 2 THEN
			indvecsig_next(2) <= indsig - 1;
		END IF;
		
		IF indsig >= 3 THEN
			indvecsig_next(1) <= indsig - 2;
		END IF;
		
		IF indsig <= D - 1 THEN
			indvecsig_next(4) <= indsig + 1;
		END IF;
		
		IF indsig <= D - 2 THEN
			indvecsig_next(5) <= indsig + 2;
		END IF;
	
	END PROCESS;

	outind <= indsig;
	outval <= valsig;
	
	outindvec <= indvecsig;

END Behavioral;

