
--file automatically generated on 07-Apr-2014 17:43:48

library IEEE;
USE IEEE.STD_LOGIC_1164.ALL;
USE IEEE.STD_LOGIC_UNSIGNED.ALL;
USE IEEE.NUMERIC_STD.ALL;

library work;
use work.allconstantsPack.ALL;

ENTITY findmintree16 IS
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
	--	enable : IN std_logic;
	--	ready : OUT std_logic;
		medvector0 : IN pixelBitWidthpipeLenDType;
		outind : OUT unsigned(7 DOWNTO 0);
		outval : OUT unsigned(7 DOWNTO 0)
	);
END ENTITY findmintree16;

ARCHITECTURE Behavioral OF findmintree16 IS

--CONSTANT medindex0INIT : pixelBitWidthpipeLenDType := indices(D);

signal indsig, indsig_next : unsigned(7 DOWNTO 0);
signal valsig, valsig_next : unsigned(7 DOWNTO 0);

type medvectorType1 IS ARRAY(NATURAL RANGE 1 TO 8) OF unsigned(7 DOWNTO 0);
type medvectorType2 IS ARRAY(NATURAL RANGE 1 TO 4) OF unsigned(7 DOWNTO 0);
type medvectorType3 IS ARRAY(NATURAL RANGE 1 TO 2) OF unsigned(7 DOWNTO 0);
--type medvectorType4 IS ARRAY(NATURAL RANGE 1 TO 1) OF unsigned(7 DOWNTO 0);

BEGIN
	clkProc : PROCESS(clk, reset)
	BEGIN
		IF reset = '1' THEN
			--indsig <= to_unsigned(1,8);
			indsig <= (OTHERS => '0');
			valsig <= (OTHERS => '0');
		ELSIF (clk'event AND clk = '1') THEN
			--IF enable = '1' THEN
			--	ready <= '1';
				indsig <= indsig_next;
				valsig <= valsig_next;
		--	END IF;
		END IF;
	END PROCESS;

	combProc : PROCESS(medvector0)
	variable medindex0 : pixelBitWidthpipeLenDType := indices(D);
	variable medvector1, medindex1 : medvectorType1;
	variable medvector2, medindex2 : medvectorType2;
	variable medvector3, medindex3 : medvectorType3;
	--variable medvector4, medindex4 : medvectorType4;
	BEGIN
		IF medvector0(1) <= medvector0(2) THEN
			medvector1(1) := medvector0(1);
			medindex1(1) := medindex0(1);
		ELSE
			medvector1(1) := medvector0(2);
			medindex1(1) := medindex0(2);
		END IF;

		IF medvector0(3) <= medvector0(4) THEN
			medvector1(2) := medvector0(3);
			medindex1(2) := medindex0(3);
		ELSE
			medvector1(2) := medvector0(4);
			medindex1(2) := medindex0(4);
		END IF;

		IF medvector0(5) <= medvector0(6) THEN
			medvector1(3) := medvector0(5);
			medindex1(3) := medindex0(5);
		ELSE
			medvector1(3) := medvector0(6);
			medindex1(3) := medindex0(6);
		END IF;

		IF medvector0(7) <= medvector0(8) THEN
			medvector1(4) := medvector0(7);
			medindex1(4) := medindex0(7);
		ELSE
			medvector1(4) := medvector0(8);
			medindex1(4) := medindex0(8);
		END IF;

		IF medvector0(9) <= medvector0(10) THEN
			medvector1(5) := medvector0(9);
			medindex1(5) := medindex0(9);
		ELSE
			medvector1(5) := medvector0(10);
			medindex1(5) := medindex0(10);
		END IF;

		IF medvector0(11) <= medvector0(12) THEN
			medvector1(6) := medvector0(11);
			medindex1(6) := medindex0(11);
		ELSE
			medvector1(6) := medvector0(12);
			medindex1(6) := medindex0(12);
		END IF;

		IF medvector0(13) <= medvector0(14) THEN
			medvector1(7) := medvector0(13);
			medindex1(7) := medindex0(13);
		ELSE
			medvector1(7) := medvector0(14);
			medindex1(7) := medindex0(14);
		END IF;

		IF medvector0(15) <= medvector0(16) THEN
			medvector1(8) := medvector0(15);
			medindex1(8) := medindex0(15);
		ELSE
			medvector1(8) := medvector0(16);
			medindex1(8) := medindex0(16);
		END IF;


	--next stage:
		IF medvector1(1) <= medvector1(2) THEN
			medvector2(1) := medvector1(1);
			medindex2(1) := medindex1(1);
		ELSE
			medvector2(1) := medvector1(2);
			medindex2(1) := medindex1(2);
		END IF;

		IF medvector1(3) <= medvector1(4) THEN
			medvector2(2) := medvector1(3);
			medindex2(2) := medindex1(3);
		ELSE
			medvector2(2) := medvector1(4);
			medindex2(2) := medindex1(4);
		END IF;

		IF medvector1(5) <= medvector1(6) THEN
			medvector2(3) := medvector1(5);
			medindex2(3) := medindex1(5);
		ELSE
			medvector2(3) := medvector1(6);
			medindex2(3) := medindex1(6);
		END IF;

		IF medvector1(7) <= medvector1(8) THEN
			medvector2(4) := medvector1(7);
			medindex2(4) := medindex1(7);
		ELSE
			medvector2(4) := medvector1(8);
			medindex2(4) := medindex1(8);
		END IF;


	--next stage:
		IF medvector2(1) <= medvector2(2) THEN
			medvector3(1) := medvector2(1);
			medindex3(1) := medindex2(1);
		ELSE
			medvector3(1) := medvector2(2);
			medindex3(1) := medindex2(2);
		END IF;

		IF medvector2(3) <= medvector2(4) THEN
			medvector3(2) := medvector2(3);
			medindex3(2) := medindex2(3);
		ELSE
			medvector3(2) := medvector2(4);
			medindex3(2) := medindex2(4);
		END IF;


	--next stage:
	--sorry, final stage:
		
		IF medvector3(1) <= medvector3(2) THEN
			valsig_next <= medvector3(1);
			indsig_next <= medindex3(1);
		ELSE
      valsig_next <= medvector3(2);
			indsig_next <= medindex3(2);
    END IF;


	END PROCESS;

	outind <= indsig;
	outval <= valsig;

END Behavioral;

